package scenes

import (
	"context"
	"log"
	"strconv"

	"github.com/go-redis/redis/v8"
	telegram "gopkg.in/tucnak/telebot.v2"
)

/*
 Выход из чат бота

 Удаляем сессию и прощаемся
*/
func Exit(b *telegram.Bot, redis *redis.Client, ctx context.Context) interface{} {
	return func(m *telegram.Message) {
		userid := strconv.Itoa(m.Sender.ID) + ":" + strconv.Itoa(int(m.Chat.ID))

		err := redis.HDel(ctx, "users", userid).Err()
		if err != nil {
			log.Println("Ошибка удаления пользователя", err.Error())
		}
		b.Send(m.Sender, "Пока!")
	}
}
